/*
 * 
 * Licensed Materials - Property of IBM 
 *
 * IBM Sterling Selling and Fullfillment Suite 9.1 
 *
 * (c) Copyright IBM Corp. 2006, 2008 All Rights Reserved. 
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted
 * by GSA ADP Schedule Contract with IBM Corp. 
 */
// NLS_CHARSET=UTF-8
// START NON-TRANSLATABLE
/* 
Worksheet Grid 
Author: Chandni Jain
Last modified: 08/15/06
Contains generic functions like MoveUp, Down etc.
*/ 

function moveLeft()
{
	var name = document.FN_PropertyList.currentField.value ;
	if(name == '') {
		return true ;
	}

	var minCol = 1 ;
	var maxCol = parseInt(document.FN_PropertyList.colnum.value) ;
	var tmp1 = name.substring(name.indexOf('_')+1, name.lastIndexOf('_')) ;
	var x = parseInt(tmp1) ;
	var tmp2 = name.substring(name.lastIndexOf('_')+1, name.length) ;
	var y = parseInt(tmp2);
	var obj = eval('document.FN_PropertyList.data_'+x+'_'+y) ;
	var currentPos = GetCurrentPosition(obj);

	if (obj.value.length > 0 && currentPos > 0 && currentPos <= obj.value.length) {
	}
	else {
		y = parseInt(tmp2) - 1 ;
		obj = eval('document.FN_PropertyList.data_'+x+'_'+y) ;
	}

	var valid = false ;
	if (y >= minCol && y <= maxCol) {
		valid = true ;
	}

	if(valid) {
		var obj = eval('document.FN_PropertyList.data_'+x+'_'+y) ;
		obj.focus() ;
	}
	return true ;
}

function setCurrentField(obj) {
	document.FN_PropertyList.currentField.value=obj.name ;
}

function moveUp() {
	var name = document.FN_PropertyList.currentField.value ;
	if(name == '') {
		return true ;
	}

	var minRow = 1 ;
	var maxRow = parseInt(document.FN_PropertyList.rownum.value) ;

	var tmp1 = name.substring(name.indexOf('_')+1, name.lastIndexOf('_')) ;
	var x = parseInt(tmp1) - 1 ;

	var tmp2 = name.substring(name.lastIndexOf('_')+1, name.length) ;
	var y = parseInt(tmp2) ;

	var valid = false ;
	if (x >= minRow && x <= maxRow) {
		valid = true ;
	}

	if(valid) {
		var obj = eval('document.FN_PropertyList.data_'+x+'_'+y) ;
		obj.focus() ;
	}

	return true ;
}

function moveDown() {
	var name = document.FN_PropertyList.currentField.value ;
	if(name == '') {
		return true ;
	}

	var minRow = 1 ;
	var maxRow = parseInt(document.FN_PropertyList.rownum.value) ;

	var tmp1 = name.substring(name.indexOf('_')+1, name.lastIndexOf('_')) ;
	var x = parseInt(tmp1) + 1 ;

	var tmp2 = name.substring(name.lastIndexOf('_')+1, name.length) ;
	var y = parseInt(tmp2) ;

	var valid = false ;
	if (x >= minRow && x <= maxRow) {
		valid = true ;
	}

	if(valid) {
		var obj = eval('document.FN_PropertyList.data_'+x+'_'+y) ;
		obj.focus() ;
	}
	return true ;
}

function GetCurrentPosition(TxtObj) {
	var pos = 0;
	if (TxtObj.createTextRange){
		rg = document.selection.createRange().duplicate();
		rg.moveStart('textedit',-1);
		pos = rg.text.length;
	}
	else if (TxtObj.setSelectionRange){
		pos = TxtObj.selectionEnd;
	}
	return pos;
}

function moveRight() {
	var name = document.FN_PropertyList.currentField.value ;
	if(name == '') {
		return true ;
	}

	var minCol = 1 ;
	var maxCol = parseInt(document.FN_PropertyList.colnum.value) ;

	var tmp1 = name.substring(name.indexOf('_')+1, name.lastIndexOf('_')) ;
	var x = parseInt(tmp1) ;

	var tmp2 = name.substring(name.lastIndexOf('_')+1, name.length) ;

	var y = parseInt(tmp2);
	var obj = eval('document.FN_PropertyList.data_'+x+'_'+y) ;
	var currentPos = GetCurrentPosition(obj);
	if (obj.value.length > 0 && currentPos < obj.value.length){
	}
	else{
		y = parseInt(tmp2) + 1 ;
		obj = eval('document.FN_PropertyList.data_'+x+'_'+y) ;
	}

	var valid = false ;
	if (y >= minCol && y <= maxCol) {
		valid = true ;
	}

	if(valid) {
		obj.focus() ;
	}
	return true ;
}


function processReset() {
	var formref = document.FN_PropertyList;
	formref.reset();
}

function validateNumber1(ip) {
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
    var msg_number = "The number entered is not valid";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
	removeLeadingAndTrailingBlanks(ip);
	if (ip.value.length > 0 && !isFloat(ip.value))
	{
		alert(msg_number);
		ip.focus();
		ip.value = "";
	}
}

function validateValue(ip){
	removeLeadingAndTrailingBlanks(ip);
	var val = ip.value;
	if (val.length > 0 && val.charAt(0)!= '=')
			validateNumber1(ip);
}

// END NON-TRANSLATABLE
