/*
 * 
 * Licensed Materials - Property of IBM 
 *
 * IBM Sterling Selling and Fullfillment Suite 9.1 
 *
 * (c) Copyright IBM Corp. 2002, 2002 All Rights Reserved. 
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted
 * by GSA ADP Schedule Contract with IBM Corp. 
 */
function isEmpty(inputStr) {
    if (inputStr == "" || inputStr == null) {
	return true
    }
    return false
}

function isNumber(inputStr) {
    if (isEmpty(inputStr)) {
    	return false;
    }
    for (var i = 0; i < inputStr.length; i++) {
	var oneChar = inputStr.substring(i, i + 1)
	if (oneChar < "0" || oneChar > "9") {
	    return false
	}
   }
   return true
}

//-- Converts date passed in mm/dd/yyyy format to Date object.
function newDate(passedValue) {   
   var makeDate = new Date()
   var firstSlash=passedValue.indexOf("/")
   var lastSlash=passedValue.lastIndexOf("/")
   var month=passedValue.substr(0,firstSlash);
   var day=passedValue.substring(firstSlash+1,lastSlash)
   var year=passedValue.substr(lastSlash+1)

   if (!isNumber(year) || !isNumber(month) || !isNumber(day) ||
   	year < 0 || month < 1 || month > 12 || day < 1 || day > 31) {
   	return null;
   }
   if (year < 50) {
   	year = 20 + year;
   }
   var newDate = new Date(year,month-1,day)
   return newDate
}

// return true if the date is a past date
// the input is a date object
function isPast(inputDate) {

    var today = new Date();
    //alert( today);
    //alert( inputDate);
    var startTime = today.getTime();
    var endTime = inputDate.getTime(); 
    if (startTime > endTime)
    {
        return true;
    }
    return false;
}


