/*
 * 
 * Licensed Materials - Property of IBM 
 *
 * IBM Sterling Selling and Fullfillment Suite 9.1 
 *
 * (c) Copyright IBM Corp. 2002, 2005 All Rights Reserved. 
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted
 * by GSA ADP Schedule Contract with IBM Corp. 
 */
// NLS_CHARSET=UTF-8
// START NON-TRANSLATABLE

	var day_array = new Array("1","2","3","4","5","6","7","8","9","10",
							"11","12","13","14","15","16","17","18","19","20",
							"21","22","23","24","25","26","27","28","29","30","31");
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
	var month_array = new Array("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
	var startYr = 1970;
	var endYr = 2200;
	
	function startGreaterThanEndDate(startDayLB, startMonthLB, startYearLB,
									 endDayLB, endMonthLB, endYearLB)
	{
		var startDay = startDayLB.options[startDayLB.selectedIndex].value;
		var startMonth = startMonthLB.options[startMonthLB.selectedIndex].value;
		var startYear = startYearLB.options[startYearLB.selectedIndex].value;
		
		var endDay = endDayLB.options[endDayLB.selectedIndex].value;
		var endMonth = endMonthLB.options[endMonthLB.selectedIndex].value;
		var endYear = endYearLB.options[endYearLB.selectedIndex].value;

		var startdate = new Date(startYear, startMonth, startDay);
		var enddate = new Date(endYear, endMonth,  endDay);

		var startTime = startdate.getTime();
		var endTime = enddate.getTime();
		if (startTime > endTime)
		{
			return true;
		}

		return false;
	}
	
	function startGreaterThanEndTime(startDayLB, startMonthLB, startYearLB, startHrLB, startMinLB,
									 endDayLB, endMonthLB, endYearLB, endHrLB, endMinLB)
	{
		var startDay = startDayLB.options[startDayLB.selectedIndex].value;
		var startMonth = startMonthLB.options[startMonthLB.selectedIndex].value;
		var startYear = startYearLB.options[startYearLB.selectedIndex].value;
		var startHr = startHrLB.options[startHrLB.selectedIndex].value;
		var startMin = startMinLB.options[startMinLB.selectedIndex].value;
		
		var endDay = endDayLB.options[endDayLB.selectedIndex].value;
		var endMonth = endMonthLB.options[endMonthLB.selectedIndex].value;
		var endYear = endYearLB.options[endYearLB.selectedIndex].value;
		var endHr = endHrLB.options[endHrLB.selectedIndex].value;
		var endMin = endMinLB.options[endMinLB.selectedIndex].value;

		var startdate = new Date(startYear, startMonth, startDay, startHr, startMin, 0);
		var enddate = new Date(endYear, endMonth,  endDay, endHr, endMin, 0);

		var startTime = startdate.getTime();
		var endTime = enddate.getTime();
		if (startTime > endTime)
		{
			return true;
		}

		return false;
	}
	
	function buildDays(selDay, selMonth, selYear, comboBox)
	{
		var leapYear = (selYear%4 > 0) ? false : true;
		var feb = (selMonth == month_array[1]) ? true : false;
		var length = month_array.length
		for (var i = 0; i <= 27; i++)
		{
			comboBox[i] = new Option(day_array[i], day_array[i], false, false);
		}
		if(feb)	
		{
			if(leapYear)
			{
				comboBox[28] = new Option(day_array[28], day_array[28], false, false);
			}
		}
		else if (selMonth == month_array[3] || selMonth == month_array[5] || 
				 selMonth == month_array[8] || selMonth == month_array[10] )
		{
			for (i = 28; i <= 29; i++)
			{
				comboBox[i] = new Option(day_array[i], day_array[i], false, false);
			}	
		}
		else
		{
			for (i = 28; i <= 30; i++)
			{
				comboBox[i] = new Option(day_array[i], day_array[i], false, false);
			}	
		}
		comboBox.options[selDay-1].selected = true;
	}


	function buildMonths(selMonth, comboBox)
	{
		for (var i = 0; i <= 11; i++)
		{
			comboBox[i] = new Option(month_array[i], i, false, false);
			if (selMonth == month_array[i])
			{
				comboBox.options[i].selected = true;		
			}
			else
			{
				comboBox.options[i].selected = false;
			}
		}		
	}

	function buildYears(selYear, comboBox)
	{
		for(i = startYr; i <= endYr; i++)
		{
			comboBox[i-startYr] = new Option(i, i, false, false);	
		}
		if(selYear > endYr) selYear = endYr;
		comboBox.options[selYear-startYr].selected = true;
	}

	//Some code may seem redundant but is actually necessary to work in Netscape
	function monthChanged(daycb, monthcb, yearcb)
	{
		var selDay = daycb.selectedIndex;
		var selMonth = monthcb.selectedIndex;		
		var selYear = yearcb[yearcb.selectedIndex].text;
		var leapYear = (selYear%4 > 0) ? false : true;
		var dayLength = daycb.length;
		if (selMonth == 1)
		{
			if (leapYear)
			{
				if(dayLength < 29)
				{
					daycb[28] = new Option(day_array[28], day_array[28], false, false);
					daycb.options[selDay].selected = true;
				}
				else if(dayLength > 29)
				{
					for (i= dayLength-1; i > 28; i--)
					{
						daycb[i] = null;	
					}
					if ( selDay > 27 )
					{
						daycb.options[0].selected = true;		
					}
					else
					{
						daycb.options[selDay].selected = true;
					}
				}	
			}	
			else
			{
				if(dayLength > 28)
				{
					for (i= dayLength-1; i > 27; i--)
					{
						daycb[i] = null;	
					}
					if ( selDay > 27 )
					{
						daycb.options[0].selected = true;		
					}
					else
					{
						daycb.options[selDay].selected = true;
					}
				}	
			}
		}
		else if (selMonth == 3 || selMonth == 5 || selMonth == 8 || selMonth == 10 )
		{
			if(dayLength < 30)
			{
				for (i= dayLength; i < 30; i++)
				{
					daycb[i] = new Option(day_array[i], day_array[i], false, false);
				}
				daycb.options[selDay].selected = true;
			}
			else if(dayLength > 30)
			{
				for (i= dayLength-1; i > 29; i--)
				{
					daycb[i] = null;	
				}
				if ( selDay > 29 )
				{
					daycb.options[0].selected = true;		
				}
				else
				{
					daycb.options[selDay].selected = true;
				}
			}	
		}
		else
		{
			if(dayLength < 31)
			{
				for (i= dayLength; i < 31; i++)
				{
					daycb[i] = new Option(day_array[i], day_array[i], false, false);
				}
				daycb.options[selDay].selected = true;
			}
		}		
	}

	function yearChanged(daycb, monthcb, yearcb)
	{
		var selDay = daycb.selectedIndex;
		var selYear = yearcb[yearcb.selectedIndex].text;
		var leapYear = (selYear%4 > 0) ? false : true;
		var dayLength = daycb.length;
		if (monthcb.selectedIndex == 1)
		{
			if (leapYear)
			{
				if(dayLength == 28)
				{
					daycb[28] = new Option(day_array[28], day_array[28], false, false);
					daycb.options[selDay].selected = true;
				}
					
			}	
			else
			{
				if(dayLength == 29)
				{
					daycb[28] = null;
				}	
				if ( selDay > 27 )
				{
					daycb.options[0].selected = true;		
				}
				else
				{
					daycb.options[selDay].selected = true;
				}
			}
		}
	}

	function init(StartDays, StartMonths, StartYears, EndDays, EndMonths, EndYears, nukeNum)
	{
		for ( var i = 0; i < nukeNum; i++)
		{
			if (StartDays.options.length > 0)
				StartDays.options[0] = null;
		}
		for ( var i = 0; i < nukeNum; i++)
		{
			if (StartMonths.options.length > 0)
				StartMonths.options[0] = null;	
		}	
		for ( var i = 0; i < nukeNum; i++)
		{
			if (StartYears.options.length > 0)
				StartYears.options[0] = null;		
		}
		for ( var i = 0; i < nukeNum; i++)
		{
			if (EndDays.options.length > 0)
				EndDays.options[0] = null;		
		}
		for ( var i = 0; i < nukeNum; i++)
		{
			if (EndMonths.options.length > 0)
				EndMonths.options[0] = null;		
		}
		for ( var i = 0; i < nukeNum; i++)
		{
			if (EndYears.options.length > 0)
				EndYears.options[0] = null;
		}
	}
// END NON-TRANSLATABLE
