/*
 * 
 * Licensed Materials - Property of IBM 
 *
 * IBM Sterling Selling and Fullfillment Suite 9.1 
 *
 * (c) Copyright IBM Corp. 2005, 2005 All Rights Reserved. 
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted
 * by GSA ADP Schedule Contract with IBM Corp. 
 */
// NLS_CHARSET=UTF-8
// START NON-TRANSLATABLE
    var descriptions;
 	function setRealListValues()
    {
    }

	function initPage(f)
	{
	    if ( f.PartnerServiceList_PartnerService_ServiceName)
        {
            f.PartnerServiceList_PartnerService_ServiceName.onchange = servicesChangeHandler;
        }
        if ( document.PartnerForm.BusinessID)
        {
            document.PartnerForm.BusinessID.focus();
        }
	    initServiceDesc();
	}


    function servicesChangeHandler(e)
    {
        changeServiceDescr();
    }


    function changeServiceDescr()
    {
        var comboBox = document.PartnerForm.PartnerServiceList_PartnerService_ServiceName;
        var listBox = document.PartnerForm.PartnerServiceList_PartnerService_ServiceDescription;
        addToListBox(comboBox, listBox);
	}


    function initServiceDesc()
    {
        // In Netscape 6.2, the selected specification on the option is getting lost.
        // Hence the following workaround. We should remove the workaround when we move to
        // Netspace 7 etc. Fix for 4577
        // Begin workaround
        var comboBox = document.PartnerForm.PartnerServiceList_PartnerService_ServiceName;
        if ( !comboBox)
        {
            return;
        }
        for (i = 0; i < comboBox.length; i++)
		{
			if (comboBox.options[i].defaultSelected == true)
			{
				comboBox.selectedIndex = i;
				break;
			}
		}
		// End workaround
		changeServiceDescr();
    }


    function checkServicesInput( )
    {
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
        var msg_totalEmployees = "Total Number of Employees";
        var msg_nextFYRevenue = "Next FY Revenue";
        var msg_currentFYRevenue = "Current FY Revenue";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
        var f = document.PartnerForm;
        if(f.NumEmployees != null)
			if(checkInteger(f.NumEmployees.value, msg_totalEmployees ) == false)
		    		return false;

		if(f.PotRevNextFy != null)
			if(checkDecimal(f.PotRevNextFy.value, msg_nextFYRevenue ) == false)
			    return false;

   		if(f.PotRevCurrFy != null)
			if(checkDecimal(f.PotRevCurrFy.value, msg_currentFYRevenue ) == false)
		    return false;
    }

    function validateMandatoryFields()
    {
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
        var msg_requireOrgId = "Please enter Organization ID.";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
        if ( document.PartnerForm.BusinessID)
        {
            if ( isNewlyNullOrTrimmedEmpty(document.OriginalFieldValues.BusinessID,
                                           document.PartnerForm.BusinessID)
                 == true )
            {
                alert(msg_requireOrgId );
                document.PartnerForm.BusinessID.focus();
                return false;
            }
        }
    }

    function clickServicesTab(primaryTab, secondaryTab, next, deleteorduplicate)
    {
        if (validateMandatoryFields() == false)
        {
            return;
        }
        if ( checkServicesInput() == false)
        {
            return;
        }
	    if ( deleteorduplicate != null &&
		    deleteorduplicate == "Duplicate" )
        {
            if ((document.PartnerForm._CurrentIndex.value >= document.PartnerForm._TotalNumOfServices.value)||
                (document.PartnerForm._NoOfCachedServices.value >= document.PartnerForm._TotalNumOfServices.value))

            {
// START QUOTE TRANSLATABLE
                var msg_tooManyChoices = "There are only "
                      + document.PartnerForm._TotalNumOfServices.value
                      + " choices allowed."
// END QUOTE TRANSLATABLE
                alert(msg_tooManyChoices);
                return;
            }

        }

      if ( document.PartnerForm._Tab.value != primaryTab ||
	     document.PartnerForm._SubTab.value != secondaryTab )
		document.PartnerForm._CurrentIndex.value = "0";

      document.PartnerForm._Tab.value = primaryTab;
	  if ( secondaryTab != null )
	      document.PartnerForm._SubTab.value = secondaryTab;
	  if (next != null )
	      document.PartnerForm._next.value = next;

	  if ( deleteorduplicate != null &&
		  deleteorduplicate == "Delete" )
		  document.PartnerForm._Delete.value = "true";
	  else
	  if ( deleteorduplicate != null &&
		  deleteorduplicate == "Duplicate" )
		  document.PartnerForm._Duplicate.value = "true";

      document.PartnerForm.submit();
    }
	function addToListBox(comboBox, listBox)
    {
		i = comboBox.selectedIndex;
        if ( i == -1)
            return;
        listBox.value = descriptions[i];
    }


    
// END NON-TRANSLATABLE
